<?php

class meta_customer extends WC_API_Resource {

    protected $base = '/meta_customer';

    public function register_routes($routes) {



        # GET /Customer



        $routes[$this->base] = array(
            array(array($this, 'get_meta_customer'), WC_API_Server::READABLE | WC_API_SERVER::EDITABLE | WC_API_SERVER::ACCEPT_DATA),
        );
        return $routes;
    }

    public function get_meta_customer() {
        $is_membership_plugin_enabled = 0;

        //check if membership plugin is enabled
        if (in_array('woocommerce-memberships/woocommerce-memberships.php', apply_filters('active_plugins', get_option('active_plugins')))) {
            $is_membership_plugin_enabled = 1;
        }
        if (in_array('woocommerce-multiple-customer-addresses/woocommerce-multiple-customer-addresses.php', apply_filters('active_plugins', get_option('active_plugins')))) {
            $is_multiple_address_plugin_enabled = 1;
        }
        if (in_array('woocommerce-smart-coupons/woocommerce-smart-coupons.php', apply_filters('active_plugins', get_option('active_plugins')))) {
            $is_smart_coupon_plugin_enabled = 1;
        }
        
        // They want to update or add data
        //echo "test:";
       // print_r($_REQUEST);

        $id = $_REQUEST["id"];

        $data = json_decode(base64_decode($_REQUEST["data"]), true);
        $nsrole = base64_decode($_REQUEST["roles"]);
        $cap = base64_decode($_REQUEST["cap"]);
        $caps = json_decode(base64_decode($_REQUEST["caps"]), true);

        echo "\n";
        echo "id = " . $id . "\n";
        echo "data = " . json_encode($data) . "\n";
        echo "role = " . $nsrole . "\n";
        echo "cap = " . $cap . "\n";
        echo "caps = " . json_encode($caps) . "\n";
		echo '<br /><br />MULTI ADDRESS';

        if (empty($id)) {
            echo json_encode(array("errors" => "Missing id argument. POST"));
            exit;
        }

        if ($is_membership_plugin_enabled) {
            //configuration customer mapping options
            $co_options = get_option("In8_Customer_CO", []);
            if (!empty($co_options) && isset($co_options['membership_post_id']) && !empty($co_options['membership_post_id']) && isset($co_options['membership_mapped_netsuite_id']) && !empty($co_options['membership_mapped_netsuite_id'])) {
                $customer_membership_map = array_combine($co_options['membership_mapped_netsuite_id'], $co_options['membership_post_id']);
            }
            //delete existing membership
            $WC_Memberships_User_Memberships = new WC_Memberships_User_Memberships();
            if (!empty($data) && is_array($data) && array_key_exists('membership_plan', $data)) {
                $WC_Memberships_User_Memberships->delete_user_memberships($id);
            }

            $membership_action = 'create';
        }
 echo "data = section \n";
  if ($data != "") {
            foreach ($data as $key => $val) {
	            do_action( 'in8_endpoint_customer_meta_post_before_update', $key, $val, $id );
                if ($is_membership_plugin_enabled && $key == 'membership_plan') {
	
	                if( !is_array($val) ){
		                $val = [$val];
	                }
                	
                    if (isset($customer_membership_map) && !empty($customer_membership_map) && is_array($val)) {
                        foreach ($val as $plan_ns_id) {
                            if (array_key_exists($plan_ns_id, $customer_membership_map)) { // if plan is mapped to Netsuite
                                // Create user membership
                                $user_membership = wc_memberships_create_user_membership(
                                        array(
                                    'user_id' => $id,
                                    'plan_id' => $customer_membership_map[$plan_ns_id] //get plan value
                                        ), $membership_action
                                );
                            }
                        }
                    }
					
                }
				if( $key == 'addresses' ){
					echo '<br /><br />MULTI ADDRESS 1';
		            $this->save_netsuite_addresses($id, $val);
	            }
				
                //added by kirit on 17-2-2018
                if($is_smart_coupon_plugin_enabled && $key=='creditmemos'){
                    global $wpdb;
                    foreach($val as $creditmemo){

                        if(!empty($creditmemo['internalId']) && $creditmemo['status']=='open'){
                            $user_coupon=get_user_meta($id,'user_coupon',true);
                            $smart_coupon_id=$wpdb->get_var('select post_id from '.$wpdb->prefix.'postmeta where meta_value='.$creditmemo['internalId']);
                            
                            if(empty($smart_coupon_id)){
                                $smart_coupon=$GLOBALS['woocommerce_smart_coupon'];
                                $user_info = get_userdata($id);
                                $email=$user_info->user_email;
                                $amount=abs($creditmemo['total']);
                                $coupon_codes=$smart_coupon->generate_smart_coupon( $email, $amount, null, null, 'smart_coupon');
                                $smart_coupon_id=$wpdb->get_var("select ID from ".$wpdb->prefix."posts where post_title='".$coupon_codes[$email][0]['code']."'");

                                if(!empty($smart_coupon_id)){
                                    update_post_meta($smart_coupon_id,'internalId',$creditmemo['internalId']);
                                    update_post_meta($smart_coupon_id,'usage_limit',1);
                                    update_post_meta($smart_coupon_id,'creditmemo','yes');
                                }
                            }
                            else
                            {
                                update_post_meta($smart_coupon_id,'coupon_amount',abs($creditmemo['total']));
                                update_post_meta($smart_coupon_id,'creditmemo','yes');
                                if($creditmemo['status']!='open'){                  
                                    update_post_meta($smart_coupon_id,'expiry_date',date('Y-m-d',time()-300));
                                }
                            }
                        }
                    }
                }
                // smart coupon code ended.

				
				//Allows custom groups mapping from customer
				$group = explode('_', $key);				
				if ($group[0] == 'grouped') {
					$groupval = explode('_', $val);
					
					if($groupval[1] == 'delete'){
						Groups_User_Group::delete( $id,  $groupval[0] );
					}else{
						Groups_User_Group::create( [ 'user_id' => $id, 'group_id' => $val ] );
					}
				}
				
				if ($key == 'group') {
					    Groups_User_Group::deleted_user( $id );
						foreach ($val as $grp) {
							Groups_User_Group::create( [ 'user_id' => $id, 'group_id' => $grp ] );
						}
						//update_user_meta($id, 'grouptest', 'true');;
				} else {
                    update_user_meta($id, $key, $val);
                }
            }
        }
	echo "role = section \n";	
        if ($nsrole != "") {
			$user = new WP_User($id);
            $user->set_role($nsrole);
            //wp_update_user(array('ID' => $id, 'role' => $nsrole));
        }
echo "cap = section \n";
        if ($cap != "") {
            $user = new WP_User($id);
            $user->add_cap($cap);
        }

        // If the capabilities were sent, remove all capabitilies before assigining
        if ($caps != "") {
echo "caps= section \n";
            $user = new WP_User($id);
			print_r($user);

            //get wp user data
            $user_data = get_userdata($id);
			print_r($user_data);

            if (is_object($user_data)) {
                //get user exiting capabilities
                $user_caps = $user_data->allcaps;
                
                if (!empty($user_caps)) {
                    
                    foreach ($user_caps as $user_cap) {
						print_r($user_cap);
                        $user->remove_cap($user_cap);
                    }
                    
                }
            }
            
            foreach ($caps as $value) {
                $user->add_cap($value);
				print_r($value);
            }
        }

        echo json_encode(array("success" => "true ok2"));

        exit;
    }
	
	public function save_netsuite_addresses($user, $val){
		// if an address exists on wc but not on netsuite, add it
		$addresses = get_user_meta($user, '_wcmca_additional_addresses', true);
		if(empty($addresses)){
			//echo '<br /><br />SAVE MULTI ADDRESS EMPTY';
			//return;
		}
		$addresses_new = [];
		$not_found_addresses = [];
		foreach($val as $key => $ns_address){
			// check if it exists
			$found = false;
			foreach($addresses as $k => $wc_address){
				if( $wc_address['internalId'] == $ns_address['internalId'] ){
					$found = true;
					$addresses_new[] = $this->return_wc_address_array($user, $ns_address);
					break;
				}
			}
			
			// doesn't exist
			if( !$found ){
				$not_found_addresses[] = $ns_address;
			}
		}
		foreach($not_found_addresses as $addr){
			$addresses_new[] = $this->return_wc_address_array($user, $addr);
		}
		update_user_meta($user, '_wcmca_additional_addresses', $addresses_new);
		echo '<br /><br />SAVE MULTI ADDRESS UPDATED';
	}
	public function return_wc_address_array($user, $arr){
		$type = $arr['defaultBilling'] == 'T' ? 'billing' : 'shipping';
		if( apply_filters('in8_multiple_addresses_default_shipping', false) ){
			$type = $arr['defaultShipping'] == 'T' ? 'shipping' : 'billing';
		}
		echo '<br /><br />MULTI ADDRESS 3'.$type;
		$isDefault = 0;
		if( $type == 'shipping' && $arr['defaultShipping'] == 'T'){
			$isDefault = 1;
		}
		if( $type == 'billing' && $arr['defaultBilling'] == 'T'){
			$isDefault = 1;
		}
		
		$first_name = '';
		$last_name = '';
		
		if( !empty($arr['addressee']) ) {
			$addressee = explode( ' ', $arr['addressee'] );
			$first_name = $addressee[0];
			$last_name = end($addressee);
		}
		
		$ret = [
			'type'                       => $type,
			'user_id'                    => $user,
			'address_internal_name'      => $arr['label'],
			$type.'_first_name'         => $first_name,
			$type.'_last_name'          => $last_name,
//			$type.'_company'            => $arr[''],
//			$type.'_email'              => $arr[''],
			$type.'_phone'              => $arr['phone'],
			$type.'_country'            => $arr['country'],
			$type.'_address_1'          => $arr['addr1'],
			$type.'_address_2'          => $arr['addr2'],
			$type.'_city'               => $arr['city'],
			$type.'_state'              => $arr['state'],
			$type.'_postcode'           => $arr['zip'],
			'internalId'           		=> $arr['internalId'],
		];
		
		if( $isDefault ){
			$ret[$type.'_is_default_address'] = 1;
		}
		
		return $ret;
	}

}
